﻿#include <winsock2.h>
#include <Ws2tcpip.h>
#pragma comment(lib,"ws2_32.lib")
#include <conio.h>
#include <string>
#include <stdio.h>
#include <windows.h>

BOOL ExecuteApplication(LPTSTR pszCommandLine, BOOL bWait = FALSE);

int main()
{
	ExecuteApplication("./L_LumbusReceiver.exe");
	ExecuteApplication("./R_LumbusReceiver.exe");

	WSAData wsaData;
	WSAStartup(MAKEWORD(2, 0), &wsaData);

	SOCKET sock = socket(AF_INET, SOCK_DGRAM, 0);
		
	char destination[] = "127.0.0.1";

	struct sockaddr_in dest_l;
	memset(&dest_l, 0, sizeof(dest_l));
	dest_l.sin_port = htons(11111);
	dest_l.sin_family = AF_INET;
	inet_pton(AF_INET, destination, &dest_l.sin_addr.s_addr);

	struct sockaddr_in dest_r;
	memset(&dest_r, 0, sizeof(dest_r));
	dest_r.sin_port = htons(22222);
	dest_r.sin_family = AF_INET;
	inet_pton(AF_INET, destination, &dest_r.sin_addr.s_addr);

	float pitch = 0;
	float roll = 0;
	float rotate_max = 26.0;//最大揺動角[deg]
	float d = 1.0;//刻み回転角[deg]
	float d_max = 26.0;//刻み回転角の上限値[deg]
	char key = 0;
	while (1)
	{
		key = _getch();
		if (key == 0xFFFFFFE0)
		{
			key = _getch();

			switch (key)
			{
			case 0x52: d += 0.01; break;//Insert
			case 0x53: d -= 0.01; break;//Delete
			case 0x48: pitch -= d; break;//↑
			case 0x50: pitch += d; break;//↓
			case 0x4B: roll += d; break;//←
			case 0x4D: roll -= d; break;//→
			}
		}
		else if(key == 0x0d) pitch = roll = 0;//reset
		
		if (d > d_max) d = d_max;
		else if (d < 0.0) d = 0.0;
		if (roll > rotate_max) roll = rotate_max;
		else if (roll < -rotate_max) roll = -rotate_max;
		if (pitch > rotate_max) pitch = rotate_max;
		else if (pitch < -rotate_max) pitch = -rotate_max;
	
		printf("D = %.2f, Pitch = %.2f, Roll = %.2f\n", d, pitch, roll);

		std::string str_pitch; str_pitch = std::to_string(pitch);
		std::string str_roll; str_roll = std::to_string(roll);

		char str_split[2] = ",";
		char str_data[256];
		sprintf_s(str_data, "%s%s%s\n", str_pitch.c_str(), str_split, str_roll.c_str());
		sendto(sock, str_data, 256, 0, (struct sockaddr *)&dest_l, sizeof(dest_l));
		sendto(sock, str_data, 256, 0, (struct sockaddr *)&dest_r, sizeof(dest_r));
	}
	closesocket(sock);
	WSACleanup();

	return 0;
}

BOOL ExecuteApplication(LPTSTR pszCommandLine, BOOL bWait /*= FALSE*/)
{
	STARTUPINFO  si;
	ZeroMemory(&si, sizeof(STARTUPINFO));
	PROCESS_INFORMATION  pi;
	ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));

	if (CreateProcess(NULL,
		pszCommandLine,
		NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
	{
		CloseHandle(pi.hThread);
		if (bWait)
		{
			WaitForSingleObject(pi.hProcess, INFINITE);
		}
		CloseHandle(pi.hProcess);
		return TRUE;
	}
	return FALSE;
}